--- Makefile.modules.orig	2012-07-16 21:45:52.000000000 +0000
+++ Makefile.modules	2012-07-16 21:27:14.000000000 +0000
@@ -46,36 +46,54 @@
 
 .if defined(_PREMKINCLUDED)
 # MPM section:
-# << TO BE WRITTEN >>
-.if defined (SLAVE_PORT_MPM)
-PLIST_SUB+=	PREFORK="@comment " WORKER="@comment " EVENT="@comment "
-PKGNAMESUFFIX=	-${SLAVE_PORT_MPM}
-.else
-.   if ${WITH_MPM} != "prefork"
-PKGNAMESUFFIX=		-${WITH_MPM:L}
-.   if ${WITH_MPM} != "itk"
-WITH_THREADS=		yes
-WITH_THREADS_MODULES=	yes
-WITHOUT_MODULES+=	cgi
-.   endif
-.      if ${WITH_MPM:L} == "worker"
-PLIST_SUB+=	PREFORK="@comment " WORKER="" EVENT="@comment "
-.      elif  ${WITH_MPM:L} == "event"
-PLIST_SUB+=	PREFORK="@comment " WORKER="@comment " EVENT=""
-.      elif  ${WITH_MPM:L} == "itk"
-PLIST_SUB+=	PREFORK="@comment " WORKER="@comment " EVENT="@comment "
-EXTRA_PATCHES+=	${PATCHDIR}/mpm-itk-${MPM_ITK_VERSION}
-.   if defined (WITH_ITK_PERDIR_REGEX)
-EXTRA_PATCHES+= ${PATCHDIR}/mpm-itk-perdir-regex
-.   endif
-.      else
-IGNORE=		"Unknown MPM: ${WITH_MPM}"
-.      endif
-.   else
-PLIST_SUB+=	PREFORK="@comment " WORKER="@comment " THREADPOOL="@comment " EVENT="@comment "
-.   endif
-.else
-PLIST_SUB+=	PREFORK="@comment " WORKER="@comment " EVENT="@comment "
+.if defined(WITH_MPM_WORKER)
+. if (defined(WITH_MPM_ITK) || defined(WITH_MPM_EVENT) || defined (WITH_MPM_PERUSER))
+IGNORE+=        Select only one MPM module to compile.
+. endif
+. if (!defined(WITH_THREADS))
+IGNORE+= mpm_worker requires WITH_THREADS.
+. endif
+#PLIST_SUB+=	PREFORK="@comment " WORKER="" EVENT="@comment "
+WITH_MPM= worker
+WITHOUT_MODULES+=     cgi
+.endif
+
+.if defined(WITH_MPM_ITK)
+. if (defined(WITH_MPM_EVENT) || defined (WITH_MPM_PERUSER))
+IGNORE+=        Select only one MPM module to compile.
+. endif
+. if defined(WITH_THREADS)
+IGNORE+=        mpm_itk conflicts with WITH_THREADS option.
+. endif
+#PLIST_SUB+=	PREFORK="@comment " WORKER="@comment " EVENT="@comment "
+WITH_MPM= itk
+EXTRA_PATCHES+=       ${.CURDIR}/files/mpm-itk-${MPM_ITK_VERSION}
+EXTRA_PATCHES+=       ${.CURDIR}/files/mpm-itk-perdir-regex
+.endif
+
+.if defined(WITH_MPM_EVENT)
+. if defined (WITH_MPM_PERUSER)
+IGNORE+=        Select only one MPM module to compile.
+. endif
+. if (!defined(WITH_THREADS))
+IGNORE+= mpm_event requires WITH_THREADS.
+. endif
+#PLIST_SUB+=	PREFORK="@comment " WORKER="@comment " EVENT=""
+WITHOUT_MODULES+=     cgi
+WITH_MPM= event
+.endif
+
+.if defined(WITH_MPM_PERUSER)
+. if (!defined(WITH_THREADS))
+IGNORE+= mpm_event requires WITH_THREADS.
+. endif
+#PLIST_SUB+=	PREFORK="@comment " WORKER="@comment " THREADPOOL="@comment " EVENT="@comment "
+WITHOUT_MODULES+=     cgi
+WITH_MPM= peruser
+WITH_SLAVE_MPM= peruser
+EXTRA_PATCHES+=         ${.CURDIR}/files/httpd-2.2.3-peruser-0.3.0.patch
+EXTRA_PATCHES+=         ${.CURDIR}/files/httpd-2.2.3-peruser-0.3.0-dc3.patch
+EXTRA_PATCHES+=         ${.CURDIR}/files/httpd-2.2.3-peruser-0.3.0-dc3-r57.patch
 .endif
 
 # xDBM section